#-----------------------------------------------------------------------------
#
# Thomas Thomassen
# thomas[at]thomthom[dot]net
#
#-----------------------------------------------------------------------------

require 'sketchup.rb'
require 'TT_Lib/core.rb'
require 'TT_Lib/gui.rb'
require 'TT_Lib/window.rb'

#-----------------------------------------------------------------------------


module TT_Lib
 module GUI
	
	# @deprecated Incomplete! WIP.
	#
	# @todo Convert boolean lists to checkboxes.
	# @todo Support for descriptions.
	# @todo Option to remember last values.
	# @todo Hash input
	#
	# @since 1.2.0
	def self.inputbox(*args)
		# Unfortunatly, since the OSX version doesn't support modal Webdialogs
		# we have to fall back to the built-in input box until that's been changed.
		if TT_Lib.is_mac?
			return UI.messagebox(args)
		else
			return self.inputbox_ex(args)
		end
	end
	
	private
	
	# @since 1.2.0
	def self.inputbox_ex(*args)
		
		prompts = ''
		defaults = ''
		lists = ''
		
		window = GUI::Window.new
		
		0.upto(prompts.rindex) { |i|
			label = 'lorem ipsum'
			data = 'x'
			
			# Container
			c = Container.new
			c.height = 25
			window.add_control(c)
			# Label
			l = Label.new(label)
			l.position(5, '49%', nil, 5)
			# Determine type
			#list = lists[i].to_lower
			#type = :checkbox if list == 'yes|no' || list == 'on|off' || list == 'true|false'
			type = :checkbox unless lists[i].match(/^yes\|no$|^on\|off$|^true\|false$/i).nil?
			
			case type
			when :string
				x = Textbox.new(data)
				x.position(5, nil, nil, '51%')
				x.width = '45%'
				c.add_control(x)
			when :integer
				x = Textbox.new(data)
				x.position(5, nil, nil, '51%')
				x.width = '45%'
				c.add_control(x)
			when :float
				x = Textbox.new(data)
				x.position(5, nil, nil, '51%')
				x.width = '45%'
				c.add_control(x)
			when :lenght
				x = Textbox.new(data)
				x.position(5, nil, nil, '51%')
				x.width = '45%'
				c.add_control(x)
			when :list
				x = Dropdown.new(data)
				x.position(5, nil, nil, '51%')
				x.width = '45%'
				c.add_control(x)
			when :checkbox
				x = Checkbox.new(data)
				x.position(5, nil, nil, '51%')
				x.width = '45%'
				c.add_control(x)
			end
		}
		
		# OK Cancel
		c = Container.new
		c.height = 25
		window.add_control(c)
		
		b = Button.new('OK') {
			# OK Stuff
		}
		c.add_control(b)
		
		b = Button.new('Cancel') {
			# OK Stuff
		}
		c.add_control(b)
		
		window.show_window(true)
		# Get values
		
		return result # (array OR nil)
	end
	
	
	
  # @deprecated Old experiment
  # @since 1.1.0
  class InputBox < Window
	
	# @since 1.1.0
	def add_textbox(label, default='')
		c = Container.new
		c.height = 25
		self.add_control(c)
		
		l = Label.new(label)
		l.position(5, '49%', nil, 5)
		c.add_control(l)
		
		t = Textbox.new(default)
		t.position(5, nil, nil, '51%')
		t.width = '45%'
		c.add_control(t)
	end
	
	# @since 1.1.0
	def add_button(caption, &proc)
		c = Container.new
		c.height = 25
		self.add_control(c)
		
		b = Button.new(caption, &proc)
		c.add_control(b)
	end
		
  end # class InputBox
  
 end # module GUI
end # module TT_Lib