#-----------------------------------------------------------------------------
#
# Thomas Thomassen
# thomas[at]thomthom[dot]net
#
#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------

module TT_Lib
 
 # @private
 # @deprecated Experimental!
 module Tools
	
	C_WINDOW_FRAME = Sketchup::Color.new(64, 64, 64)
	C_WINDOW_CONTENT = Sketchup::Color.new(92, 92, 92)
	
	# @private
	# @deprecated Experimental!
	class Powertool #< Tool
		attr_accessor( :windows )
		
		def initialize
			@windows = []
		end
		
		def draw(view)
			@windows.each { |window|
				window.draw(view)
			}
		end
	end

	
	# @private
	# @deprecated Experimental!
	class Control
		attr_accessor( :ui_id )
		attr_accessor( :left, :top, :height, :width )
		attr_accessor( :parent, :window )
		
		def move(left, top)
			@left = left
			@top  = top
		end
		
		def size(width, height)
			@width  = width
			@height = height
		end
		
		def position(top, right, bottom, left)
			@top	= top
			@right	= right
			@bottom	= bottom
			@left	= left
		end
		
		def right
			return left + width
		end
		
		def bottom
			return top + height
		end
		
	end
		
	
	# @private
	# @abstract +Container+ and +Window+ implements this
	# @deprecated Experimental!
	module ContainerElement
		attr :children
		
		def initialize
			super
			@children = []
		end
		
		def add_control(control)
			throw :invalid_control unless control.is_a?(Control)
			@children << control
			control.parent = self
		end
	end
	
	
	# @private
	# @deprecated Experimental!
	class Container < Control
		include ContainerElement
	end
	
	
	# @private
	# @deprecated Experimental!
	class Window < Control
		include ContainerElement
		
		def initialize(left, right, width, height)
			@left = left
			@top = top
			@width = width
			@height = height
		end
		
		def draw(view)
			# Window Background
			frame = []
			frame << [@left, @top, 0]
			frame << [@left, bottom(), 0]
			frame << [right(), bottom(), 0]
			frame << [right(), @top, 0]
			view.drawing_color = C_WINDOW_FRAME
			view.draw2d(GL_QUADS, frame)
			# Content Frame
			content = []
			content << [@left + 3, @top + 13, 0]
			content << [@left + 3, bottom() - 3, 0]
			content << [right() - 3, bottom() - 3, 0]
			content << [right() - 3, @top + 13, 0]
			view.drawing_color = C_WINDOW_CONTENT
			view.draw2d(GL_QUADS, frame)
		end
			
	end
 
 end # module Tools
end # module TT_Lib